SystemOrganization addCategory: #TusLibros!

TestCase subclass: #TestTusLibros
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 5/30/2013 17:37'!
aCartWithBooks

	| aCart aCatalog |
	
	aCatalog := Dictionary new.
	aCatalog at: self someBook put: 50.00.
	aCatalog at: self someOtherBook put: 69.99.
	
	aCart := Cart newWithCatalog: aCatalog.
	aCart add: self someBook.
	aCart add: self someBook.
	^aCart.		! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/9/2013 20:05'!
aCashier

	| aMerchantProcessor |
	aMerchantProcessor :=  MerchantProcessorSimulator newWithSimulator: [  ].
	^ Cashier newWithSalesBook: (Set new) andMerchantProcessor: aMerchantProcessor andToday: Date today.! !

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 6/3/2013 20:29'!
aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor

	^ Cashier newWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor andToday: Date today.! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/5/2013 20:32'!
aCatalog

	| aCatalog |
	
	aCatalog := Dictionary new.
	aCatalog at: self someBook put: 50.00.
	aCatalog at: self someOtherBook put: 69.99.
	
	^aCatalog.
	
! !

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 6/9/2013 20:25'!
aLoadedCart

	| aCatalog aCart |
	
	aCatalog := Dictionary new.
	aCatalog at: self someBook put: 50.00.
	aCatalog at: self someOtherBook put: 69.99.
	
	aCart := Cart newWithCatalog: aCatalog.
	
	aCart add: self someBook. 
	aCart add: self someBook.
	
	^aCart.! !

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 5/30/2013 17:40'!
aNewCart

	| aCatalog |
	
	aCatalog := Dictionary new.
	aCatalog at: self someBook put: 50.00.
	aCatalog at: self someOtherBook put: 69.99.
	
	^ Cart newWithCatalog: aCatalog.! !

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 5/30/2013 17:39'!
aNewCartWithEmptyCatalog

	^ Cart newWithCatalog: Dictionary new.! !

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 5/30/2013 17:38'!
aNonExpiredCreditCard

	^ CreditCard newWithOwner: 'Luis' withNumber: 123456 withExpirationDate: ((Date today) addDays: 60 ).! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/5/2013 20:33'!
aSecurity

	| aSecurity |
	
	aSecurity := Security newSecurityWithUsers: self users.
	
	^aSecurity.
	
! !

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 6/9/2013 20:54'!
anExistingSession


	^Session newSessionWithElement: (self aLoadedCart)  andLastUsedTime: (self clock now) andExpirationTime: self expirationTime.! !

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 5/30/2013 17:18'!
anExpiredCreditCard

	^ CreditCard newWithOwner: 'Luis' withNumber: 123456 withExpirationDate: ((Date today) subtractDays: 60 ).! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/5/2013 21:23'!
carts

	| carts |
	
	carts := Dictionary new.
	
	^carts.
	
! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/9/2013 20:09'!
clock

	| clock |
	
	clock  := ClockSimulator  newClock: TimeStamp now.
	
	^clock.
	
! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/5/2013 20:36'!
correctPassword
	
	^ '1234'
	
! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/5/2013 20:36'!
correctUser
	
	^ 'pepe'
	
! !

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 6/9/2013 20:30'!
expirationTime

	^1800.! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/9/2013 20:30'!
incorrectId

	^ (-1).! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/9/2013 19:59'!
interface
	
	^ self interface: self sessions andSalesBook: self salesBook.! !

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 6/9/2013 20:15'!
interface: aListOfSessions andSalesBook: aSalesBookByUser

	| aInterface |
	
	aInterface := RestInterface newInterfaceWithSecurity: (self aSecurity) andCatalog: (self aCatalog)  andCashier: (self aCashier) andSessions: aListOfSessions andSalesByUser: aSalesBookByUser andClock: self clock.
	
	^aInterface.
	
! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/9/2013 21:00'!
interface: aListOfSessions andSalesBook: aSalesBookByUser andClock: aClock

	| aInterface |
	
	aInterface := RestInterface newInterfaceWithSecurity: (self aSecurity) andCatalog: (self aCatalog)  andCashier: (self aCashier) andSessions: aListOfSessions andSalesByUser: aSalesBookByUser andClock: aClock.
	
	^aInterface.
	
! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/5/2013 21:16'!
invalidPassword
	
	^ '88882'
	
! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/5/2013 20:38'!
nonExistingUsername
	
	^ 'cacho'
	
! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/9/2013 19:59'!
salesBook

	| salesBook |
	
	salesBook := Dictionary new.
	
	^salesBook.
	
! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/9/2013 19:58'!
sessions

	| sessions |
	
	sessions := Dictionary new.
	
	^sessions.
	
! !

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 5/29/2013 19:48'!
someBook

	^ 123456.! !

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 5/29/2013 19:48'!
someOtherBook

	^ 987654.! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/5/2013 20:40'!
someOtherCorrectPassword
	
	^ '1432'
	
! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/5/2013 20:40'!
someOtherCorrectUser
	
	^ 'pepe2'
	
! !

!TestTusLibros methodsFor: '1 Tests Cart' stamp: 'PabloRago 5/27/2013 21:54'!
test01CreatedCartShouldBeEmpty
	
	
	self assert: (self aNewCart) isEmpty.! !

!TestTusLibros methodsFor: '1 Tests Cart' stamp: 'PabloRago 5/29/2013 19:39'!
test02BooksAddedToTheCartShouldBeInTheCart
	
	self assert: (((self aNewCart) add: self someBook) includes: self someBook).! !

!TestTusLibros methodsFor: '1 Tests Cart' stamp: 'PabloRago 5/29/2013 20:09'!
test03TheCartShouldOnlyContainTheAddedBooks
	
	| aCart |
	
	aCart := self aNewCart.
	aCart add: self someBook. 
	aCart add: self someOtherBook.

	self assert: (aCart includes: self someBook).
	self assert: (aCart includes: self someOtherBook).
	self assert: (aCart size = 2).! !

!TestTusLibros methodsFor: '1 Tests Cart' stamp: 'PabloRago 5/29/2013 19:39'!
test04TheCartCanContainTwoCopiesOfTheSameBook
	
	| aCart |
	
	aCart := self aNewCart.
	aCart add: self someBook. 
	aCart add: self someBook.

	self assert: (aCart includes: self someBook).
	self assert: (aCart size = 2).! !

!TestTusLibros methodsFor: '1 Tests Cart' stamp: 'PabloRago 5/31/2013 00:09'!
test05TheCartCanContainManyCopiesOfManyBooks
	
	| aCart |
	
	aCart := self aNewCart.
	
	aCart add: self someBook. 
	aCart add: self someBook.
	aCart add: self someOtherBook.
	aCart add: self someOtherBook.
	aCart add: self someOtherBook.
	
	self assert: ((aCart occurrencesOf: self someBook) = 2).
	self assert: ((aCart occurrencesOf: self someOtherBook) = 3).! !

!TestTusLibros methodsFor: '1 Tests Cart' stamp: 'PabloRago 5/31/2013 00:10'!
test06ItemsThatAreNotInTheCatalogCannotBeAddedToTheCart
	
	| aCart |
	
	aCart := self aNewCartWithEmptyCatalog .
	
	self should: [ aCart add:  self someBook ] 
	raise: Error 
	withExceptionDo: [ :anError | self assert: (anError description = ('Error: ', Cart invalidItemErrorMessage)) ].
		
	self assert: aCart isEmpty. ! !

!TestTusLibros methodsFor: '2 Test checkout' stamp: 'PabloRago 6/3/2013 21:33'!
test07AnEmptyCartCannotBeCheckedOut

	|aSalesBook aCashier aMerchanProcessor|
	
	aSalesBook := Set new.
	aMerchanProcessor := MerchantProcessorSimulator newWithSimulator: [  ^Error signal: MerchantProcessor shouldntHaveCalledMe  ].
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchanProcessor .

	self should: [ 
		aCashier checkout: (self aNewCart) withCreditCard: (self aNonExpiredCreditCard) 
		]
	raise: Error 
	withExceptionDo: [ :anError | self assert: (anError description = ('Error: ', Cashier emptyCartCheckoutErrorMessage)) ].
		
	self assert: (self aNewCart isEmpty).
	self assert: ( aSalesBook isEmpty  ).! !

!TestTusLibros methodsFor: '2 Test checkout' stamp: 'PabloRago 6/3/2013 21:33'!
test08ACashierShouldNotAcceptAnExpiredCreditCard

	|aSalesBook aCashier aMerchanProcessor|
	
	aSalesBook := Set new.
	aMerchanProcessor := MerchantProcessorSimulator newWithSimulator: [ ^Error signal: MerchantProcessor shouldntHaveCalledMe ].
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchanProcessor .
	
	self should: [ 
		aCashier checkout: (self aCartWithBooks) withCreditCard: (self anExpiredCreditCard) 
		]
	raise: Error 
	withExceptionDo: [ :anError | self assert: (anError description = ('Error: ', Cashier expiredCreditCardErrorMessage)) ].

	self assert: ( aSalesBook isEmpty  ).! !

!TestTusLibros methodsFor: '2 Test checkout' stamp: 'PabloRago 6/3/2013 20:33'!
test09SaleAmountShouldBeEqualToTheTotalPriceOfThePurchasedBooks

	| aCart aCatalog aSale aSalesBook aCashier aMerchanProcessor|

	aSalesBook := Set new.
	aMerchanProcessor := MerchantProcessorSimulator newWithSimulator: [  ].
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchanProcessor .
	
	aCatalog := Dictionary new.
	aCatalog at: (self someBook)  put: 50.00.
	aCatalog at: (self someOtherBook)  put: 69.99.
	
	aCart := Cart newWithCatalog: aCatalog.
	aCart add: (self someBook). 
	aCart add: (self someBook).
	aCart add: (self someBook).
	
	aSale := aCashier checkout: aCart withCreditCard: (self aNonExpiredCreditCard) .
	
	self assert: (aSale totalAmount = 150.00).
	self assert: (aSalesBook includes: aSale).
		
	

	! !

!TestTusLibros methodsFor: '2 Test checkout' stamp: 'PabloRago 6/3/2013 20:44'!
test10ACashierShouldStopSaleIfCreditCardHasNotEnoughCredit

	|aSalesBook aCashier aMerchanProcessor|
	
	aSalesBook := Set new.
	aMerchanProcessor := MerchantProcessorSimulator newWithSimulator: [ ^Error signal: Cashier notEnoughCreditErrorMessage ].
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchanProcessor .
	
	self should: [ 
		aCashier checkout: (self aCartWithBooks) withCreditCard: (self aNonExpiredCreditCard ) 
		]
	raise: Error 
	withExceptionDo: [ :anError | self assert: (anError description = ('Error: ',Cashier notEnoughCreditErrorMessage)) ].

	self assert: ( aSalesBook isEmpty  ).! !

!TestTusLibros methodsFor: '2 Test checkout' stamp: 'PabloRago 6/3/2013 20:53'!
test11ACashierShouldStopSaleIfCreditCardHasBeenStolen

	|aSalesBook aCashier aMerchanProcessor|
	
	aSalesBook := Set new.
	aMerchanProcessor := MerchantProcessorSimulator newWithSimulator: [ ^Error signal: Cashier creditCardStolenMessage ].
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchanProcessor .
	
	self should: [ 
		aCashier checkout: (self aCartWithBooks) withCreditCard: (self aNonExpiredCreditCard ) 
		]
	raise: Error 
	withExceptionDo: [ :anError | self assert: (anError description = ('Error: ',Cashier creditCardStolenMessage)) ].

	self assert: ( aSalesBook isEmpty  ).! !

!TestTusLibros methodsFor: '3 Test Interface' stamp: 'MartinCarreiro 6/5/2013 20:31'!
test12InterfaceCanNotCreateCartIfUserIsInvalid
	
	
	self should:[
	self interface createCartFor: self nonExistingUsername withPassword: self correctPassword.]
	raise: Error
	withExceptionDo: [ :anError | self assert: (anError description = ('Error: ', self userOrPasswordInvalidMessage)) ].
	! !

!TestTusLibros methodsFor: '3 Test Interface' stamp: 'MartinCarreiro 6/9/2013 17:44'!
test13InterfaceCanNotCreateCartIfPasswordIsInvalid
	
	self should:[
	self interface createCartFor: self correctUser withPassword: self invalidPassword.]
	raise: Error
	withExceptionDo: [ :anError | self assert: (anError description = ('Error: ', self userOrPasswordInvalidMessage )) ].
	! !

!TestTusLibros methodsFor: '3 Test Interface' stamp: 'MartinCarreiro 6/9/2013 20:01'!
test14InterfaceShouldReturnIdWhenCreatingUserAndPasswordCorrect
	
	| id salesBookByUser sessions |
	
	salesBookByUser := self salesBook.
	sessions := self sessions.
	
	id := (self interface:sessions andSalesBook: salesBookByUser ) createCartFor: self correctUser withPassword: self correctPassword.
	
	self assert: (sessions includesKey: id) .
	! !

!TestTusLibros methodsFor: '3 Test Interface' stamp: 'PabloRago 6/9/2013 20:42'!
test15CheckoutOfAValidCartShouldBeRegisteredInSalesByUserBook
	
	
	| salesBookByUser sessions restInterface aSale |
	
	salesBookByUser := self salesBook.
	sessions := self sessions.
	
	sessions at: 1 put: self anExistingSession.
	
	restInterface := self interface: sessions andSalesBook: salesBookByUser.
	
	aSale := restInterface checkoutCart: 1 withCreditCard: self aNonExpiredCreditCard .
	
	self assert: ((salesBookByUser at: 1) includes: aSale) .
	
	! !

!TestTusLibros methodsFor: '3 Test Interface' stamp: 'MartinCarreiro 6/9/2013 20:33'!
test50InterfaceShouldReturnErrorIfCartDoesNotExist
	
	| salesBookByUser sessions interface |
	
	salesBookByUser := self salesBook.
	sessions := self sessions.
	interface := (self interface:sessions andSalesBook: salesBookByUser ).
	
	self should: [ 
		interface addToCart: self incorrectId Book: self someBook.
		]
	raise: Error 
	withExceptionDo: [ :anError | self assert: (anError description = ('Error: ',Session elementDoesNotExistMessage)) ].
	
	! !

!TestTusLibros methodsFor: '3 Test Interface' stamp: 'MartinCarreiro 6/9/2013 21:09'!
test51InterfaceShouldReturnErrorIfSessionExpired
	
	| salesBookByUser sessions interface clock |
	
	salesBookByUser := self salesBook.
	sessions := self sessions.
	clock := self clock.
	sessions at: 1 put: self anExistingSession.
	interface := (self interface:sessions andSalesBook: salesBookByUser andClock: clock).
	
	self should: [ 
		clock passTimeInSeconds: (self expirationTime + 10).
		interface addToCart: 1 Book: self someBook.
		]
	raise: Error 
	withExceptionDo: [ :anError | self assert: (anError description = ('Error: ',Session expiratedSessionMessage)) ].
	
	! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/5/2013 20:39'!
userOrPasswordInvalidMessage
	
	^ Security userOrPasswordInvalid.
	
! !

!TestTusLibros methodsFor: 'something' stamp: 'MartinCarreiro 6/5/2013 20:40'!
users

	| users |
	
	users := Dictionary new.
	users at: self correctUser put: self correctPassword.
	users at: self someOtherCorrectUser put: self someOtherCorrectPassword.
	
	^users.
	
! !

Object subclass: #Cart
	instanceVariableNames: 'bag catalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/29/2013 20:28'!
invalidItemErrorMessage

	^ 'The item cannot be added.'! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/29/2013 20:22'!
newWithCatalog: aCatalog

	| aCart |
	
	aCart := Cart new.
	^ aCart initializeWithCatalog: aCatalog.! !

!Cart methodsFor: 'adding' stamp: 'PabloRago 5/30/2013 17:44'!
add: anElement 

	(catalog includesKey: anElement) 
	ifTrue: 
		[bag add: anElement ]
	ifFalse: 
		[ ^ Error signal: (self class invalidItemErrorMessage)  ].
	! !

!Cart methodsFor: 'accessing' stamp: 'PabloRago 5/29/2013 19:55'!
includes: anElement 

	^bag includes:  anElement .! !

!Cart methodsFor: 'initialization' stamp: 'PabloRago 5/29/2013 21:23'!
initializeWithCatalog: aCatalog 

	catalog := aCatalog.
	bag := Bag new.! !

!Cart methodsFor: 'accessing' stamp: 'PabloRago 5/29/2013 19:55'!
isEmpty

	^ bag isEmpty.! !

!Cart methodsFor: 'accessing' stamp: 'PabloRago 5/29/2013 19:55'!
occurrencesOf: anElement 

	^bag occurrencesOf:  anElement .! !

!Cart methodsFor: 'accessing' stamp: 'PabloRago 5/29/2013 19:56'!
size 

	^ bag size.! !

!Cart methodsFor: 'accessing' stamp: 'PabloRago 5/31/2013 00:01'!
totalAmount

	| totalAmount |
	
	totalAmount := 0.
	bag do: [ :anItem | totalAmount := totalAmount + (catalog at: anItem) ].
	^totalAmount.
	
	"^(bag reduce:  [ :anItem :anotherItem | (catalog at: anItem) + (catalog at: anotherItem) ])."! !

Object subclass: #Cashier
	instanceVariableNames: 'salesBook today merchantProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/3/2013 20:53'!
creditCardStolenMessage

	^ 'Cannot checkout with stolen credit card.'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/29/2013 21:08'!
emptyCartCheckoutErrorMessage

	^ 'Cannot checkout an empty cart.'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/30/2013 17:25'!
expiredCreditCardErrorMessage

	^ 'Cannot checkout with an expired credit card.'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/30/2013 17:19'!
expredCreditCardErrorMessage

	^ 'Cannot checkout with an expired credit card.'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/3/2013 20:13'!
newWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor andToday: today

	|aCashier|
	
	aCashier := Cashier new.
	^ aCashier initializeWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor andToday: today.! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/3/2013 20:34'!
notEnoughCreditErrorMessage

	^ 'Cannot checkout without enough credit.'! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/3/2013 20:52'!
checkout: aCart withCreditCard: aCreditCard
	
	| aSale saleTotalAmount aTransactionId|
	
	self signalIfCartIsEmptyFor: aCart.
	self signalIfCreditCardIsExpiredFor: aCreditCard.
	
	saleTotalAmount := aCart totalAmount.
	
	[aTransactionId := merchantProcessor debitWithCreditCard: aCreditCard  andTotal: aCart.
	aSale := Sale newWithCart: aCart withCreditCard: aCreditCard withTransactionID: aTransactionId for: saleTotalAmount.  
	salesBook add: aSale.
	^aSale.] 
		on: Error
		do: [ :anError | 
				"El unico error que handleamo' es Timeout, viteh"
				(anError description = 'Timeout') ifTrue: [self persistCSV.] .
				 ^Error signal: anError messageText.
			].
	
	
	
	
	 ! !

!Cashier methodsFor: 'initialization' stamp: 'PabloRago 6/1/2013 19:13'!
initialize

	salesBook := Set new.! !

!Cashier methodsFor: 'initialization' stamp: 'PabloRago 6/3/2013 20:13'!
initializeWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor andToday: aDate

	salesBook := aSalesBook.
	merchantProcessor  := aMerchantProcessor.
	today := aDate.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/30/2013 23:50'!
signalIfCartIsEmptyFor: aCart
	
	(aCart isEmpty)
	ifTrue: 
		[ ^ Error signal: (self class emptyCartCheckoutErrorMessage)  ].
	
	
	 ! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/5/2013 21:11'!
signalIfCreditCardIsExpiredFor: aCreditCard
	
	(aCreditCard isExpiratedOn: today)
	ifTrue: 
		[ ^ Error signal: (self class expiredCreditCardErrorMessage)  ].
	
	 ! !

Object subclass: #ClockSimulator
	instanceVariableNames: 'timeStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!ClockSimulator class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/9/2013 18:32'!
newClock: aTimeStamp

	|aClock|
	
	aClock := ClockSimulator new.
	
	^aClock initializeWithTime: aTimeStamp.

	! !

!ClockSimulator methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/9/2013 18:33'!
initializeWithTime: aTimeStamp

	timeStamp := aTimeStamp.! !

!ClockSimulator methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/9/2013 18:05'!
now

	^timeStamp .! !

!ClockSimulator methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/9/2013 21:18'!
passTimeInSeconds: seconds

	^timeStamp  := timeStamp plusSeconds: seconds.! !

Object subclass: #CreditCard
	instanceVariableNames: 'owner number expirationDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CreditCard class methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/29/2013 21:21'!
newWithOwner: anOwner withNumber: aNumber withExpirationDate: anExpirationDate

	|aCreditCard|
	
	aCreditCard := CreditCard new.
	^ aCreditCard initializeWithOwner: anOwner withNumber: aNumber withExpirationDate: anExpirationDate ! !

!CreditCard methodsFor: 'accessors' stamp: 'PabloRago 5/30/2013 17:22'!
expirationDate

	^ expirationDate.! !

!CreditCard methodsFor: 'initialization' stamp: 'PabloRago 5/29/2013 21:24'!
initializeWithOwner: anOwner withNumber: aNumber withExpirationDate: anExpirationDate 

	owner := anOwner.
	number := aNumber .
	expirationDate := anExpirationDate .

! !

!CreditCard methodsFor: 'accessors' stamp: 'MartinCarreiro 6/5/2013 21:14'!
isExpiratedOn: aDate

	^ expirationDate < aDate.! !

!CreditCard methodsFor: 'accessors' stamp: 'PabloRago 5/30/2013 17:22'!
number

	^ number.! !

!CreditCard methodsFor: 'accessors' stamp: 'PabloRago 5/30/2013 17:22'!
owner

	^ owner.! !

Object subclass: #EditorialLosPelados
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!EditorialLosPelados class methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/1/2013 19:06'!
defaultCatalog

	|aCatalog|
	
	aCatalog := Dictionary new.
	aCatalog at: 123  put: 50.00.
	aCatalog at: 124  put: 69.99.
	
 	^aCatalog.! !

Object subclass: #MerchantProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!MerchantProcessor class methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/3/2013 21:33'!
shouldntHaveCalledMe

	^ 'You shouldnt have called me'! !

MerchantProcessor subclass: #MerchantProcessorSimulator
	instanceVariableNames: 'simulated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!MerchantProcessorSimulator class methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/3/2013 20:32'!
newWithSimulator: aBlock

	| aMerchantProcessorSimulator|
	
	aMerchantProcessorSimulator := MerchantProcessorSimulator new.
	^aMerchantProcessorSimulator initializeWithSimulator: aBlock.! !

!MerchantProcessorSimulator methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/3/2013 20:18'!
debitWithCreditCard: aCreditCard andTotal: total 

	^ simulated value.! !

!MerchantProcessorSimulator methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/3/2013 20:21'!
initializeWithSimulator: aBlock

	simulated := aBlock.! !

Object subclass: #RestInterface
	instanceVariableNames: 'security catalog lastIndex clock sessions expirationTime salesByUserBook cashier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!RestInterface class methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/9/2013 20:14'!
newInterfaceWithSecurity: aSecurity andCatalog: catalog  andCashier: aCashier andSessions: sessionsDictionary andSalesByUser: aSalesByUserBook andClock: aClock

	| aRestInterface |
	aRestInterface := RestInterface new.
	
	^aRestInterface initializeInterfaceWithSecurity: aSecurity andCatalog: catalog  andCashier: aCashier andSessions: sessionsDictionary andSalesByUser: aSalesByUserBook andClock: aClock.! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/9/2013 19:47'!
addToCart: cartId Book: isbn 

	| cart session |
	
	[session := sessions at: cartId.]
	on: Error
		do: [ :anError | 
				   "Si no existe el carrito"
				 ^Error signal: Session elementDoesNotExistMessage.
			].
	
	(session hasExpired: clock now)
		ifTrue: [ 
				"Si expiro"
				^ Error signal: Session expiratedSessionMessage.
			 ].
	cart := (sessions at: cartId) element.
	cart addToCart:  self Book: isbn.
	session refreshExpiration: clock now.
	^ cartId.! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/9/2013 20:54'!
checkoutCart: cartID withCreditCard: aCreditCard


	| aCart aSession aSale |
	
	aSession := (sessions at: cartID).
	
	(aSession hasExpired: (clock now))  ifTrue: [
		^Error signal: 'Expired credit card'. 
	 ].

	aCart := aSession element.
	aSale := cashier checkout: aCart withCreditCard: aCreditCard.
	
	aSession refreshExpiration: clock now.

	(salesByUserBook  includesKey: cartID) ifFalse:[
		salesByUserBook at: cartID put: Set new.
	].	
	(salesByUserBook at: cartID) add: aSale.
	
	^ aSale transactionID.! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/9/2013 18:58'!
createCartFor: user withPassword: password

	| cart session |
	security existsUser: user withPassword: password.
	lastIndex := lastIndex + 1.
	cart := Cart newWithCatalog: catalog.
	
	"La idea es que tengo el expirationTime=30 minutos, clock = es el Clock Simulator (tal vez se deberi llamar clock porque le tenes que hacer otro clock"
	session := Session newSessionWithElement: cart andLastUsedTime: (clock now) andExpirationTime: expirationTime.
	
	sessions at: lastIndex put: session	.
	^ lastIndex.! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/9/2013 20:13'!
initializeInterfaceWithSecurity: aSecurity andCatalog: aCatalog andCashier: aCashier andSessions: sessionsDictionary andSalesByUser: aSalesByUserBook andClock: aClock

	security := aSecurity.
	catalog := aCatalog.
	cashier := aCashier.
	sessions := sessionsDictionary .
	salesByUserBook := aSalesByUserBook.
	lastIndex := 0.
	clock := aClock.
	! !

Object subclass: #Sale
	instanceVariableNames: 'cart creditCard totalAmount date transactionID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Sale class methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/1/2013 19:56'!
newWithCart: aCart withCreditCard: aCreditCard withTransactionID: aTransactionID for: saleTotalAmount

	| aSale |
	
	aSale := Sale new.
	^ aSale initializeWithCart: aCart withCreditCard: aCreditCard withTransactionID: aTransactionID for: saleTotalAmount.	
! !

!Sale methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/1/2013 20:32'!
initializeWithCart: aCart withCreditCard: aCreditCard withTransactionID: aTransactionID for: aTotalAmount

	cart := aCart.
	creditCard := aCreditCard.
	totalAmount := aTotalAmount .
	date := Date dateAndTimeNow.
	transactionID := aTransactionID.! !

!Sale methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/30/2013 23:35'!
totalAmount

	^totalAmount.! !

!Sale methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/1/2013 20:32'!
transactionID

	^transactionID.! !

Object subclass: #Security
	instanceVariableNames: 'users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Security class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/5/2013 20:13'!
newSecurityWithUsers: aUserList

	|aSecurity|
	aSecurity := Security new.
	
	^aSecurity initializeSecurityWithUsers: aUserList.! !

!Security class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/5/2013 20:28'!
userOrPasswordInvalid
	
	^ 'Usuario o Password invlidos'! !

!Security methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/5/2013 20:43'!
existsUser:user withPassword: password

	  [self assert: ((users includesKey:user) and: [(users at: user)=password ])]
		on: AssertionFailure 
		do: [  ^ Error signal: (self class userOrPasswordInvalid)    ]
	
	
	.! !

!Security methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/5/2013 20:13'!
initializeSecurityWithUsers: aUserList

	users := aUserList .! !

Object subclass: #Session
	instanceVariableNames: 'element timeStampLastAccessed expirationTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Session class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/9/2013 20:53'!
elementDoesNotExistMessage

	^'This is not the element you are looking for'! !

!Session class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/9/2013 20:53'!
expiratedSessionMessage

	^'The session is expirated, you can not use this cart anymore'! !

!Session class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/9/2013 18:57'!
newSessionWithElement: element andLastUsedTime: now andExpirationTime: expirationTime

	|aSession|
	
	aSession := Session new.
	
	^aSession initializeElement: element andLastUsedTime: now andExpirationTime: expirationTime .! !

!Session methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/9/2013 18:36'!
element

	^element.! !

!Session methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/9/2013 21:17'!
hasExpired: now

	^ now > (timeStampLastAccessed plusSeconds: expirationTime).! !

!Session methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/9/2013 18:56'!
initializeElement: anElement andLastUsedTime: now andExpirationTime:  anExpirationTime

	element := anElement .
	timeStampLastAccessed := now.
	expirationTime := anExpirationTime .! !

!Session methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/9/2013 19:32'!
refreshExpiration: now

	timeStampLastAccessed := now! !
